<meta charset="UTF-8">
<script src="https://unpkg.com/react@18/umd/react.development.js" crossorigin></script>
<script src="https://unpkg.com/react-dom@18/umd/react-dom.development.js" crossorigin></script>
<script src="https://unpkg.com/@babel/standalone/babel.js"></script>

<script type="text/babel" data-type="module">
	import {TantervihaloLoader, Subject} from './api.js';
	import "https://unpkg.com/exceljs@4.3.0/dist/exceljs.js";

	if (window.opener) {
		window.addEventListener('message', event => {
			if (event.source === window.opener) {
				switch (event.data.type) {
                    case 'init': {
						if (rendered) return;
						clearTimeout(renderTimeout)
						root.render(<XlsxVisual bytes={event.data.detail.bytes}/>);
						rendered = true;
                    }
                }
			}
		})

        window.opener.postMessage({type: 'ready'}, '*');
	}

	const root = ReactDOM.createRoot(document.body.appendChild(document.createElement('main')));
	let rendered = false;
	const renderTimeout = setTimeout(() => {
		root.render(<XlsxVisual url="../assets/PTI 2018 nappali BSc A,B,,C háló 2022 július.xlsx"/>);
		rendered = true;
    }, window.opener ? 1000 : 0)

	function render() {
		root.render(<TantervihaloVisual tantervihalo={tantervihalo}/>)
    }

	function XlsxVisual({url, bytes}) {
		const [haloEvents, setHaloEvents] = React.useState([]);
		const [loader, setLoader] = React.useState(undefined);

		async function handleBytes(bytes) {
			const workbook = new ExcelJS.Workbook;
			await workbook.xlsx.load(bytes);
			const loader = new TantervihaloLoader(workbook);
			setLoader(loader);

			loader.addEventListener('tantervihaloFound', (event) => {
				haloEvents.push(event);
				setHaloEvents([...haloEvents]);
			});
		}

		if (url) {
			React.useEffect(() => {
				setLoader(undefined);
				setHaloEvents([]);
				fetch(url)
					.then(res => res.blob())
					.then(handleBytes)
			}, [url]);
		}

		if (bytes) {
			React.useEffect(() => handleBytes(bytes), [bytes])
        }

        if (loader) {
			return haloEvents.map((event, i) => (
				<TantervihaloVisual key={i} event={event}/>
            ));
        } else {
			return "Please wait, fetching XLSX...";
        }
	}

	function ModuleVisual({module, sums=false}) {
		const fields = sums ? [
				{
					header: "Code",
					data: subject => subject.code ? <pre>{subject.code}</pre> : "Unknown ✅",
				},
				{
					header: "Name",
					data: subject => subject.name || "Unknown ⚠️",
				},
				{
					header: "Credits",
					data: ({credits: cr}) => cr ? (
						!isNaN(cr.total) ? cr.total.toString()
                            : String(cr.total) + " ⚠️ Unknown"
					) : "N/A ⚠️",
				},
				{
					header: "Recommended semester",
					data: subject => subject.recommendedSemester ? (
						subject.recommendedSemester.length ?
							<ul>{subject.recommendedSemester.map((n, i) => <li key={i}>{
								!isNaN(n)
									? n.toString()
									: String(n) + "⚠️ Unknown"
							}</li>)}</ul> : "None ⚠"
					) : "N/A ✅",
				},
			] : [
            {
				header: "Elective?",
                data: subject => subject.elective === true
                    ? "Elective"
                    : subject.elective === false
                    ? ""
                    : "N/A ⚠️️",
            },
            {
				header: "Code",
                data: subject => subject.code ? <pre>{subject.code}</pre> : "Unknown ⚠️",
            },
            {
				header: "Name",
                data: subject => subject.name || "Unknown ⚠️",
            },
            {
				header: "Discontinued?",
                data: subject => subject.discontinued === true
                    ? "Discontinued"
                    : subject.discontinued === false
                    ? ""
                    : "N/A ⚠️️",
            },
            {
                header: <span>Credits<br/><span style={{whiteSpace: 'nowrap'}}>Lect+Pr+Lab+Cons=Total</span></span>,
                data: ({credits: cr}) => cr ? `${cr.lecture}+${cr.practice}+${cr.labor}+${cr.consultation}=${cr.total}` + (
					cr.lecture+cr.practice+cr.labor+cr.consultation === cr.total
                    ? " ✅"
                    : " ⚠️"
                ) : "N/A ⚠️",
            },
			{
				header: "Assessment combined?",
				data: ({assessment}) => assessment ? (
					assessment.combined === true
                    ? "Combined"
                    : assessment.combined === false
                    ? ""
                    : "Unknown ⚠️️"
                ) : "N/A ⚠️️",
			},
            {
				header: "Assessment type",
                data: ({assessment}) => assessment ? (
					assessment.grade
						? assessment.grade.description
						: "Unknown ⚠️️"
				) : "N/A ⚠️️",
            },
            {
				header: "Recommended semester",
                data: subject => subject.recommendedSemester ? (
					subject.recommendedSemester.length ?
                        <ul>{subject.recommendedSemester.map((n, i) => <li key={i}>{
							!isNaN(n)
                                ? n.toString()
                                : String(n) + "⚠️ Unknown"
                        }</li>)}</ul> : "None ⚠️"
                ) : "N/A ⚠️",
            },
            {
				header: "Requirements",
                data: subject => subject.requirements ? (
					subject.requirements.length ?
                        <ul>{subject.requirements.map((e, i) => <li key={i}>{
                            e instanceof Subject
                                ? e.toString()
                                : JSON.stringify(e) + " ⚠️ Not found"
                        }</li>)}</ul> : "None ✅"
                ) : "N/A ⚠️",
            },
            {
				header: "Topic",
                data: subject => subject.topic ? (
					typeof subject.topic === 'symbol'
						? subject.topic.description
						: subject.topic.toString() + " ⚠ Unexpected️️"
				) : "N/A ⚠️️",
            },
            {
				header: "Specializations",
                data: subject => subject.specializations ?
					( subject.specializations.size
                        ? <ul>{[...subject.specializations].map((e, i) => <li key={i}>{
                            typeof e === 'symbol'
                                ? e.description
                                : String(e) + " ⚠️ Unexpected"
                        }</li>)}</ul>
                        : "None ⚠️"
                    ) : "N/A",
            },
        ]

		return (
			<details>
                <summary>{module.title}</summary>
                <table>
                    <tbody>
                        <tr>
                            {fields.map(({header}, i) => <th key={i}>{header}</th>)}
                        </tr>
                        {[...module].map(subject => (
                            <tr key={subject.code}>
								{fields.map((e, i) => <td key={i}>{e.data(subject)}</td>)}
                            </tr>
                        ))}
                    </tbody>
                </table>
			</details>
        );
	}

	function TantervihaloVisual({event}) {
		const [{tantervihalo}, setTantervihalo] = React.useState(event.detail);

		function updateTantervihalo() {
			setTantervihalo({tantervihalo});
		}

		React.useEffect(() => {
			const {eventTarget, promise} = event.detail;
			eventTarget.addEventListener('moduleFound', moduleEvent => {
				updateTantervihalo();
				const {eventTarget} = moduleEvent.detail;
				eventTarget.addEventListener('titleFound', updateTantervihalo)
				eventTarget.addEventListener('subjectFound', updateTantervihalo)
            })
            eventTarget.addEventListener('sumRow', updateTantervihalo)
            promise.then(updateTantervihalo)
        }, [event.detail]);

		return [
			<h1 key="h1">{tantervihalo.title}</h1>,
			...tantervihalo.modules.map((module, moduleIndex) => (
				<ModuleVisual key={`${moduleIndex}:${module.title}`}
                              module={module}/>
            )),
            <ModuleVisual key="sums" module={tantervihalo.sums} sums={true}/>,
			<details>
				<summary>JSON</summary>
				<pre>{JSON.stringify(tantervihalo)}</pre>
			</details>,
		];
	}
</script>

<style>
    details {
        margin-top: 1em;
    }

    table, td, th {
        border: 1px solid black;
    }
</style>
